import java.util.*;

public class Uthyrning {
     private List uthyrningsLista;
     private int max;

     public Uthyrning(int maxNum, List ul) {
        this.max = maxNum;
        this.uthyrningsLista = ul;
     }

     public Object lamnaUt() {
        return uthyrningsLista.remove(0);
     }

     public void taEmot(Object o) {
        uthyrningsLista.add(o);
     }
}

class Bil{
    String marke;
    public Bil(String m){
	marke=m;
    }
}


class Biluthyrning extends Uthyrning {
    public Biluthyrning(int maxNum, List<Bil> bilar) {
        super(maxNum, bilar);
    }
    public Bil lamnaUt() {
        return (Bil) super.lamnaUt();
     }

   public void taEmot(Bil b) {
       super.taEmot(b);
   }

   public void taEmot(Object o) {
     if (o instanceof Bil) {
       super.taEmot(o);
     } else {
        System.out.println("det gar inte att lagga till!");
     } 
   }

    public static void main(String[] args){
	Bil b1 = new Bil("Mazda");
	Bil b2 = new Bil("Volvo");
	List<Bil> BilLista = new ArrayList<Bil>();
	BilLista.add(b1);
	BilLista.add(b2);
	Biluthyrning bilUthyrning = new  Biluthyrning(2, BilLista);
	Bil bil = bilUthyrning.lamnaUt();
	System.out.println(bil.marke);
	bilUthyrning.taEmot(bil);
	bil = bilUthyrning.lamnaUt();
	System.out.println(bil.marke);
	bilUthyrning.taEmot(bil);
    }
}


